#!/usr/bin/perl

use strict;

my $macros = {};
open my $fm,"Macros" or die "can't open 'Macros': $!";
while ( my $l = <$fm> ) {
	chomp $l;
	next if $l =~ /^(#|$)/;
	my ( $macro,$def,$rest ) = split (/;/,$l);
	$macros->{$macro} = $def;
}

use Data::Dumper;
print Dumper($macros);

my $cbmtotalsum = 0;
my $qmtotalsum  = 0;

for my $room (@ARGV) {

	my $cbmsum = 0;
	my $qmsum  = 0;

	open my $fi,$room or die "can't open '$room': $!";
	while ( my $l = <$fi> ) {
		chomp $l;
		next if $l =~ /^(#|$)/;
		print ":in: '$l'\n";
		my @Cols = split (/;/,$l);
		if ( scalar @Cols < 2 ) {
			die "'$l' has not at least 2 ';' separated fields";
		}
		my ( $item,$count,$size_b,$size_t,$size_h,$size_f,$vol ) = @Cols;
		# print ":size: '$item - $count- $size_b,$size_t,$size_h - $size_f -  $vol'\n";
		for my $m (keys %$macros ) {
			# print ":$m -> $macros->{$m}\n";
			if ( $size_b =~ /$m/ ) {
				; # print ":found: $m\n";
			}
			if ( $size_t =~ /$m/ ) {
				; # print ":found: $m\n";
			}
			if ( $size_h =~ /$m/ ) {
				; # print ":found: $m\n";
			}
			if ( $size_f =~ /$m/ ) {
				; # print ":found: $m\n";
			}
			$size_b =~ s/${m}/$macros->{$m}/eg;
			$size_t =~ s/${m}/$macros->{$m}/eg;
			$size_h =~ s/${m}/$macros->{$m}/eg;
			$size_f =~ s/${m}/$macros->{$m}/eg;
		}
		my $size_f_vol = $size_f || 0;
		$size_f_vol =~ s/x/*/g;
		$size_f_vol = eval $size_f_vol;
		my $size = $count * $size_b * $size_t * $size_h + $size_f_vol;
		my $area = $count * $size_b * $size_t;
		if ( $size_f_vol ) {
			print "$item $count*$size_b*$size_t*$size_h+$size_f_vol\n";
		} else {
			print "$item $count*$size_b*$size_t*$size_h\n";
		}
		print "$item $count*$size_b*$size_t\n";
		# Aufrunden auf halbe cbm:
		my $cbm = int ((($size) / 1E6 + 0.499 ) * 2) / 2;
		print ":cbm: $cbm\n";
		$cbmsum += $cbm;
		# Aufrunden auf halbe qm:
		#my $qm = int ((($area) / 1E4 + 0.499 ) * 2) / 2;
		my $qm = $area / 1E4;
		print ":qm: $qm\n";
		$qmsum += $qm;
	}

	print ":cbmsum: $cbmsum\n";
	$cbmtotalsum += $cbmsum;
	print ":qmsum: $qmsum\n";
	$qmtotalsum += $qmsum;
}
print ":cbmtotalsum: $cbmtotalsum\n";
print ":qmtotalsum: $qmtotalsum\n";
